function test()
{
  RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].
        getService(Components.interfaces.nsIRDFService);

  ios = Components.classes["@mozilla.org/network/io-service;1"].
        getService(Components.interfaces.nsIIOService);

  xmlParser = '@mozilla.org/rdf/xml-parser;1';
  parser = Components.classes[xmlParser].
           createInstance(Components.interfaces.nsIRDFXMLParser);

  memory = '@mozilla.org/rdf/datasource;1?name=in-memory-datasource';
  datasource = Components.classes[memory].
               createInstance(Components.interfaces.nsIRDFDataSource);

  uri = ios.newURI("http://books.mozdev.org/rdf#", null);

  rdfString = '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:nc="http://books.mozdev.org/rdf#"><rdf:Description about="nc:root"><nc:links><rdf:Seq><rdf:li><rdf:Description nc:name="one" /></rdf:li><rdf:li><rdf:Description nc:name="two" /></rdf:li><rdf:li><rdf:Description nc:name="three" /></rdf:li></rdf:Seq></nc:links></rdf:Description></rdf:RDF>';

  parser.parseString(datasource,uri,rdfString);


  datasource = Components.classes[memory].
               createInstance(Components.interfaces.nsIRDFDataSource);

  root = RDF.GetResource('urn:root');
  predicate = RDF.GetResource('http://home.netscape.com/NC-rdf#links');
  object = RDF.GetLiteral('s');

  datasource.Assert(root,predicate,object,true);

   var s = Components.classes['@mozilla.org/rdf/xml-serializer;1'].createInstance(Components.interfaces.nsIRDFXMLSerializer);

   s.init(datasource);

   out = new Object();
   out.write = new function(buf,count)
   {
     alert(buf); return count;
   }

   s.QueryInterface(Components.interfaces.nsIRDFXMLSource).Serialize(out);

/*

item = datasource.GetAllResources();
item = item.getNext();
item.QueryInterface(Components.interfaces.nsIRDFResource);
alert(item.Value);
*/

}