      var e;

      // start the spiral
      spiral("ele", .035, 50, .40, 0);

      // Created by Jeremie Miller, jer@jabber.org

      // util to convert "123px" or "123" to a number correctly
      function _px(pixels)
      {
          loc = pixels.indexOf("px");
          if(loc != -1)
                num = pixels.substring(0, loc);
          else
                  num = pixels;
          return Number(num);
      }

      // public function to call to animate an element
      function spiral(ele, delta, rad, rate, left)
      {
	  e = document.getElementById(ele);
	  e.cdelta = delta;
	  e.cdir = 1;
	  e.cx = -1;
	  e.centerTop = _px(e.style.top);
	  e.centerLeft = left;
	  e.crad = rad;
	  e.crate = rate;
	  circle_draw(ele);
      }

      // function that does the work
      function circle_draw(ele)
      {
          try{
          // by Jeremie, http://www.jeremie.com/
          
          if(e.cx <= 1)
          {
              y = Math.sqrt(1 - (e.cx * e.cx));
              e.cx += e.cdelta;
              y *= e.cdir;
              e.style.top = e.centerTop + (y * e.crad) + 'px';
              e.style.left = e.centerLeft + (e.cx * e.crad * e.cdir) + 'px';
          }
          else
          {
              e.cdir *= -1;
              e.cx = -1;
          }
          e.crad -= e.crate;

          if(e.crad > 0) {
              setTimeout("circle_draw('" + ele + "');", 5);
              }
          }catch(e){}
      }