var pathColor = "blue";
var lineColor = "blue";
var pointerColor = "red";

var rectangleLineColor = "blue";
var rectangleFillColor = "silver";

var ellipseLineColor = "blue";
var ellipseFillColor = "silver";

var rectangleOpacity = '0.0';
var ellipseOpacity = '0.0';

var pathWidth='1';
var lineWidth='1';
var rectangleWidth='2';
var ellipseWidth='1';

var setAsCircle=false;

/***************************************************************************/

function GetColorAndUpdate(ColorWellID,mode,type)
{
  var colorObj = new Object;
  var colorWell = document.getElementById(ColorWellID);

  if (!colorWell) return;

  // Don't allow a blank color, i.e., using the "default"
  colorObj.NoDefault = true;

  window.openDialog("chrome://editor/content/EdColorPicker.xul", "_blank", "chrome,close,titlebar,modal", "", colorObj);

  // User canceled the dialog
  if (colorObj.Cancel)
    return;

  if(mode=='path') {
    pathColor=colorObj.TextColor;
  }
  else if(mode=='line') {
    lineColor=colorObj.TextColor;
  }
  else if(mode=='pointer') {
    pointerColor=colorObj.TextColor;
  }
  else if(mode=='rectangle') {
    if(type=='line')
      rectangleLineColor=colorObj.TextColor;
    else
      rectangleFillColor=colorObj.TextColor;
  }
  else if(mode=='ellipse') {
    if(type=='line')
      ellipseLineColor=colorObj.TextColor;
    else
      ellipseFillColor=colorObj.TextColor;
  }

  colorWell.setAttribute("style", "background-color:"+colorObj.TextColor+";height:18px;width:18px");
}



/***************************************************************************/

function getText()
{
  window.openDialog("text-dialog.xul", "_blank", "chrome,close,titlebar,modal", "",null);

  if(textXHTML=='' || textXHTML=='<body><br/></body>')
  {
    text = null;
  }
  else // The user actually typed something
  {
    text = textXHTML;
    canvas.appendText();

    // Tried to change class for different cursor with no success.
    // canvas.setAttribute('class','text');
  }  
}

/***************************************************************************/

function setWidth(element,type)
{
  genWidth = document.getElementById(element).getAttribute('label');

  switch(type)
  {
    case "path":
      pathWidth=genWidth;break;
    case "line":
      lineWidth=genWidth;break;
    case "rectangle":
      rectangleWidth=genWidth;break;
    case "ellipse":
      ellipseWidth=genWidth;break;
  }
}

function setOpacity(element,type)
{
  genOpacity = document.getElementById(element).getAttribute('label');

  switch(type)
  {
    case "rectangle":
      rectangleOpacity=genOpacity;break;
    case "ellipse":
      ellipseOpacity=genOpacity;break;
  }
}

/***************************************************************************/

MODE = "PATH"; // Default mode

pathElement      = document.getElementById('path');
lineElement      = document.getElementById('line');
rectangleElement = document.getElementById('rectangle');
ellipseElement   = document.getElementById('ellipse');
textElement      = document.getElementById('text');
pointerElement   = document.getElementById('pointer');

function changeMode(newMode)
{
  if(newMode != MODE)
  {
    switch(newMode)
    {
      case "PATH":
        changeE(pathElement);
        MODE = newMode;
        break;
      case "LINE":
        changeE(lineElement);
        MODE = newMode;
        break;
      case "RECTANGLE":
        changeE(rectangleElement);
        MODE = newMode;
        break;
      case "ELLIPSE":
        changeE(ellipseElement);
        MODE = newMode;
        break;
      case "TEXT":
        changeE(textElement);
        MODE = newMode;
        break;
      case "POINTER":
        changeE(pointerElement);
        MODE = newMode;
        break;
    }
  }
}

function changeE(element)
{
  pathElement.setAttribute('src','path-off.png');
  lineElement.setAttribute('src','line-off.png');
  rectangleElement.setAttribute('src','rectangle-off.png');
  ellipseElement.setAttribute('src','ellipse-off.png');
  textElement.setAttribute('src','text-off.png');
  pointerElement.setAttribute('src','pointer-off.png');

  eid=element.getAttribute('id');

  element.setAttribute('src',eid + '-on.png');

  document.getElementById(eid+'Box').setAttribute('class','shown');
  document.getElementById(MODE.toLowerCase()+'Box').setAttribute('class','hidden');
}

/***************************************************************************/

function clear()
{
  frames[1].location.reload();
  pointer = null;
  jabber.sendGroupChat(room,'',' cleared his or her whiteboard.','','','');
}